<html lang="en">
<style>
    table, td {
        border: 1px solid black;
    }
    .firstRow{
        border: 0px solid black;
    }
</style>
<head>

</head>
<body>
<div style="float: right;  height:100vh;" id="memoryListdiv">
    <table id="memoryList">
    </table>
</div>

<div id="simulationSetup" style="width: 80vw">
    <div style=" display: inline-block; width:200px;">
        <button onclick="startAutomatedStep()">Play</button>
        <button onclick="boolean_stop = true">Pause</button>
        <button onclick="manualStep()">Next Step</button>
        <button onclick="preempt()">Yield</button>
        <button onclick="myFunction()">Reload page</button>
        <br>
        Current Simulation Time: <a id="simTime">0</a>
        <br>
        <br>
        <a onclick="createJSON(this,processControlBlock,'ProcessList');"><i></i> CreateProcess JSON</a>
        <br>
        <a onclick="createJSON(this,configList,'ConfigList');"><i></i> Create Config JSON</a>
        <br>
        <a onclick="createJSON(this,instructionList,'InstructionList');"><i></i> Create Instruction JSON</a>
        <br>
        <br>
    </div>
    <div style="display: inline-block; float: right; width:350px;">
        <div>
            Process:<input type="file" id="process-input" style="float: right">
        </div>
        <br>
        <div>
            Config: <input type="file" id="config-input" style="float: right">
        </div>
        <br>
        <div>
            Instruction Set: <input type="file" id="instruction-definitions" style="float: right" >
        </div>
    </div>
</div>

<div style="width: 80vw">
    <table id="pcbTable" style="width:800px ">
        <tr>
            <td width="80px">PID</td>
            <td width="80px">Entry Time</td>
            <td width="80px">Turnaround Time</td>
            <td width="100px">Waiting Time</td>
            <td width="100px">Base Register</td>
            <td width="100px">Limit Register</td>
            <td width="120px">State</td>
            <td width="80px">PC</td>
            <td width="100px">Last Used CPU</td>
            <td width="120px">Registers</td>
            <td width="80px">Priority</td>
            <td width="80px">&#x03C4;n+1</td>
            <td width="80px">tn</td>
        </tr>
    </table>
</div>
<br>

<div>
    <div style="display: inline-block; float: left; width:600px; ">
        <select id="instructionList" onchange="displayInstructionImplementation()" style="vertical-align: top;"></select>
        <button id="newInstruction" onclick = "createNewInstructionType()" style="vertical-align: top;">Create a new Instruction </button>
        <br>
        <textarea id="instructionImplementation" onblur="saveInstructionSet()" name="instructionImplementation" cols="60" rows="20"></textarea>
        <br>
        <select id="algorithmSelection" style="vertical-align: top;">
            <option value="FCFS">FCFS</option>
            <option value="SJF">SJF</option>
            <option value="RR">RR</option>
            <option value="Priority">Priority</option>
            <option value="User Created">User Created</option>
            <option value="Runtime">Runtime</option>
        </select>

        Time Slice(RR only): <input id="timeSlice" style="vertical-align: top;" type="text" name="timeSlice" value="1">
        <br>
        <textarea id="userCreated" name="userCreated" onblur="saveSchedulingAlgorithm()" cols="60" rows="20"></textarea>
    </div>

    <div style=" display: inline-block; width:200px; vertical-align: top">
        <div style="display: inline-block; width:200px;">
            <div style="display: inline-block; float: left; width:100px; vertical-align: top">
                Registers:
            </div>
            <div style="display: inline-block; float: right; width:100px; vertical-align: top"  id="registerlistdiv">
                <ul style="float: right" id="registerlist">
                </ul>
            </div>
        </div>
        <br>
        <br>
        <div style="display: inline-block; width:200px;">
            <div style="display: inline-block; float: left; width:100px; vertical-align: top">
                Shared Variables:
            </div>
            <div style="display: inline-block; float: right; width:100px; vertical-align: top"  id="sharedvariablelistdiv">
                <ul style="float: right" id="sharedvariablelist">
                </ul>
            </div>
        </div>
        <br>
        <br>
        <div style="display: inline-block; width:200px;">
            <div style="display: inline-block; float: left; width:100px; vertical-align: top">
                Semaphores:
            </div>
            <div style="display: inline-block; float: right; width:100px; vertical-align: top"  id="semaphoreListDiv">
                <ul style="float: right" id="semaphoreList">
                </ul>
            </div>
        </div>
        <br>
        <br>
        <div style="display: inline-block; width:200px;">
            <div style="display: inline-block; float: left; width:100px; vertical-align: top">
                Devices:
            </div>
            <div style="display: inline-block; float: right; width:100px; vertical-align: top"  id="devicelistDiv">
                <ul style="float: right" id="deviceList">
                </ul>
            </div>
        </div>
    </div>
</div>

<script type="text/javascript" src="raphael.min.js"></script>
<script type="text/javascript" src="sim-0.26.js"></script>
<script type="text/javascript" src="ExtendedSim.js"></script>
<script type="text/javascript" src="frameworkFunctions.js"></script>
<script type="text/javascript" src="simulation.js"></script>
<script type="text/javascript" src="JSONParsing.js"></script>
<script type="text/javascript" src="CustomScheduler.js"></script>
<script type="text/javascript" src="instructionList.js"></script>
</body>
</html>


